// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from cob_actions:action/Dock.idl
// generated code does not contain a copyright notice

#ifndef COB_ACTIONS__ACTION__DETAIL__DOCK__BUILDER_HPP_
#define COB_ACTIONS__ACTION__DETAIL__DOCK__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "cob_actions/action/detail/dock__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace cob_actions
{

namespace action
{

namespace builder
{

class Init_Dock_Goal_dist_threshold
{
public:
  explicit Init_Dock_Goal_dist_threshold(::cob_actions::action::Dock_Goal & msg)
  : msg_(msg)
  {}
  ::cob_actions::action::Dock_Goal dist_threshold(::cob_actions::action::Dock_Goal::_dist_threshold_type arg)
  {
    msg_.dist_threshold = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_actions::action::Dock_Goal msg_;
};

class Init_Dock_Goal_stop_compare_value
{
public:
  explicit Init_Dock_Goal_stop_compare_value(::cob_actions::action::Dock_Goal & msg)
  : msg_(msg)
  {}
  Init_Dock_Goal_dist_threshold stop_compare_value(::cob_actions::action::Dock_Goal::_stop_compare_value_type arg)
  {
    msg_.stop_compare_value = std::move(arg);
    return Init_Dock_Goal_dist_threshold(msg_);
  }

private:
  ::cob_actions::action::Dock_Goal msg_;
};

class Init_Dock_Goal_stop_message_field
{
public:
  explicit Init_Dock_Goal_stop_message_field(::cob_actions::action::Dock_Goal & msg)
  : msg_(msg)
  {}
  Init_Dock_Goal_stop_compare_value stop_message_field(::cob_actions::action::Dock_Goal::_stop_message_field_type arg)
  {
    msg_.stop_message_field = std::move(arg);
    return Init_Dock_Goal_stop_compare_value(msg_);
  }

private:
  ::cob_actions::action::Dock_Goal msg_;
};

class Init_Dock_Goal_stop_topic
{
public:
  explicit Init_Dock_Goal_stop_topic(::cob_actions::action::Dock_Goal & msg)
  : msg_(msg)
  {}
  Init_Dock_Goal_stop_message_field stop_topic(::cob_actions::action::Dock_Goal::_stop_topic_type arg)
  {
    msg_.stop_topic = std::move(arg);
    return Init_Dock_Goal_stop_message_field(msg_);
  }

private:
  ::cob_actions::action::Dock_Goal msg_;
};

class Init_Dock_Goal_poses
{
public:
  explicit Init_Dock_Goal_poses(::cob_actions::action::Dock_Goal & msg)
  : msg_(msg)
  {}
  Init_Dock_Goal_stop_topic poses(::cob_actions::action::Dock_Goal::_poses_type arg)
  {
    msg_.poses = std::move(arg);
    return Init_Dock_Goal_stop_topic(msg_);
  }

private:
  ::cob_actions::action::Dock_Goal msg_;
};

class Init_Dock_Goal_frame_id
{
public:
  Init_Dock_Goal_frame_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Dock_Goal_poses frame_id(::cob_actions::action::Dock_Goal::_frame_id_type arg)
  {
    msg_.frame_id = std::move(arg);
    return Init_Dock_Goal_poses(msg_);
  }

private:
  ::cob_actions::action::Dock_Goal msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_actions::action::Dock_Goal>()
{
  return cob_actions::action::builder::Init_Dock_Goal_frame_id();
}

}  // namespace cob_actions


namespace cob_actions
{

namespace action
{

namespace builder
{

class Init_Dock_Result_message
{
public:
  explicit Init_Dock_Result_message(::cob_actions::action::Dock_Result & msg)
  : msg_(msg)
  {}
  ::cob_actions::action::Dock_Result message(::cob_actions::action::Dock_Result::_message_type arg)
  {
    msg_.message = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_actions::action::Dock_Result msg_;
};

class Init_Dock_Result_success
{
public:
  Init_Dock_Result_success()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Dock_Result_message success(::cob_actions::action::Dock_Result::_success_type arg)
  {
    msg_.success = std::move(arg);
    return Init_Dock_Result_message(msg_);
  }

private:
  ::cob_actions::action::Dock_Result msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_actions::action::Dock_Result>()
{
  return cob_actions::action::builder::Init_Dock_Result_success();
}

}  // namespace cob_actions


namespace cob_actions
{

namespace action
{

namespace builder
{

class Init_Dock_Feedback_message
{
public:
  Init_Dock_Feedback_message()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::cob_actions::action::Dock_Feedback message(::cob_actions::action::Dock_Feedback::_message_type arg)
  {
    msg_.message = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_actions::action::Dock_Feedback msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_actions::action::Dock_Feedback>()
{
  return cob_actions::action::builder::Init_Dock_Feedback_message();
}

}  // namespace cob_actions


namespace cob_actions
{

namespace action
{

namespace builder
{

class Init_Dock_SendGoal_Request_goal
{
public:
  explicit Init_Dock_SendGoal_Request_goal(::cob_actions::action::Dock_SendGoal_Request & msg)
  : msg_(msg)
  {}
  ::cob_actions::action::Dock_SendGoal_Request goal(::cob_actions::action::Dock_SendGoal_Request::_goal_type arg)
  {
    msg_.goal = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_actions::action::Dock_SendGoal_Request msg_;
};

class Init_Dock_SendGoal_Request_goal_id
{
public:
  Init_Dock_SendGoal_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Dock_SendGoal_Request_goal goal_id(::cob_actions::action::Dock_SendGoal_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_Dock_SendGoal_Request_goal(msg_);
  }

private:
  ::cob_actions::action::Dock_SendGoal_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_actions::action::Dock_SendGoal_Request>()
{
  return cob_actions::action::builder::Init_Dock_SendGoal_Request_goal_id();
}

}  // namespace cob_actions


namespace cob_actions
{

namespace action
{

namespace builder
{

class Init_Dock_SendGoal_Response_stamp
{
public:
  explicit Init_Dock_SendGoal_Response_stamp(::cob_actions::action::Dock_SendGoal_Response & msg)
  : msg_(msg)
  {}
  ::cob_actions::action::Dock_SendGoal_Response stamp(::cob_actions::action::Dock_SendGoal_Response::_stamp_type arg)
  {
    msg_.stamp = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_actions::action::Dock_SendGoal_Response msg_;
};

class Init_Dock_SendGoal_Response_accepted
{
public:
  Init_Dock_SendGoal_Response_accepted()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Dock_SendGoal_Response_stamp accepted(::cob_actions::action::Dock_SendGoal_Response::_accepted_type arg)
  {
    msg_.accepted = std::move(arg);
    return Init_Dock_SendGoal_Response_stamp(msg_);
  }

private:
  ::cob_actions::action::Dock_SendGoal_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_actions::action::Dock_SendGoal_Response>()
{
  return cob_actions::action::builder::Init_Dock_SendGoal_Response_accepted();
}

}  // namespace cob_actions


namespace cob_actions
{

namespace action
{

namespace builder
{

class Init_Dock_GetResult_Request_goal_id
{
public:
  Init_Dock_GetResult_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::cob_actions::action::Dock_GetResult_Request goal_id(::cob_actions::action::Dock_GetResult_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_actions::action::Dock_GetResult_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_actions::action::Dock_GetResult_Request>()
{
  return cob_actions::action::builder::Init_Dock_GetResult_Request_goal_id();
}

}  // namespace cob_actions


namespace cob_actions
{

namespace action
{

namespace builder
{

class Init_Dock_GetResult_Response_result
{
public:
  explicit Init_Dock_GetResult_Response_result(::cob_actions::action::Dock_GetResult_Response & msg)
  : msg_(msg)
  {}
  ::cob_actions::action::Dock_GetResult_Response result(::cob_actions::action::Dock_GetResult_Response::_result_type arg)
  {
    msg_.result = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_actions::action::Dock_GetResult_Response msg_;
};

class Init_Dock_GetResult_Response_status
{
public:
  Init_Dock_GetResult_Response_status()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Dock_GetResult_Response_result status(::cob_actions::action::Dock_GetResult_Response::_status_type arg)
  {
    msg_.status = std::move(arg);
    return Init_Dock_GetResult_Response_result(msg_);
  }

private:
  ::cob_actions::action::Dock_GetResult_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_actions::action::Dock_GetResult_Response>()
{
  return cob_actions::action::builder::Init_Dock_GetResult_Response_status();
}

}  // namespace cob_actions


namespace cob_actions
{

namespace action
{

namespace builder
{

class Init_Dock_FeedbackMessage_feedback
{
public:
  explicit Init_Dock_FeedbackMessage_feedback(::cob_actions::action::Dock_FeedbackMessage & msg)
  : msg_(msg)
  {}
  ::cob_actions::action::Dock_FeedbackMessage feedback(::cob_actions::action::Dock_FeedbackMessage::_feedback_type arg)
  {
    msg_.feedback = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_actions::action::Dock_FeedbackMessage msg_;
};

class Init_Dock_FeedbackMessage_goal_id
{
public:
  Init_Dock_FeedbackMessage_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Dock_FeedbackMessage_feedback goal_id(::cob_actions::action::Dock_FeedbackMessage::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_Dock_FeedbackMessage_feedback(msg_);
  }

private:
  ::cob_actions::action::Dock_FeedbackMessage msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_actions::action::Dock_FeedbackMessage>()
{
  return cob_actions::action::builder::Init_Dock_FeedbackMessage_goal_id();
}

}  // namespace cob_actions

#endif  // COB_ACTIONS__ACTION__DETAIL__DOCK__BUILDER_HPP_
